
function StateSuggestions1() {
//alert ("Meow..");
this.states = 
[
"849 || DEO N FRESH AIR FRESHENER HOOKS MRP 53","866 || DEO N FRESH AIR FRESHENER HOOKS MRP 55","859 || AVL DEO N FRESH AIR FRESHENER 50G 3+1 FREE MRP 150","867 || DAZ.DEO N FRESH PERFUME BAG 10GM 3+1 FREE OFFER PACK MRP-180","860 || AVL DEO N FRESH AIR FRESHENER 75G 3+1 FREE MRP 225","841 || EYE.SUBANITHRA LIQUIDATOR 45 NIGHTS BUY 2 GET 1 FREE MRP 150","842 || SUBANITHRA LIQUIDATOR COMBI PACK MRP-89","864 || AVL SUBANITHRA HERBAL INCENSE STICKS MRP-180","871 || AVL SUBANITHRA HERBAL INCENSE STICKS MRP-180","761 || DAZ.TALCUM POWDER 300G BUY 1 GET 1 OFFER PACK MRP-150","762 || DAZ.TALCUM POWDER 100G BUY 1 GET 1 OFFER PACK MRP 90","760 || DAZ.TALCUM POWDER 30G MRP 10"];
}

/**
 * Request suggestions for the given autosuggest control. 
 * @scope protected
 * @param oAutoSuggestControl The autosuggest control to provide suggestions for.
 */
StateSuggestions1.prototype.requestSuggestions = function (oAutoSuggestControl /*:AutoSuggestControl*/,
                                                          bTypeAhead /*:boolean*/) {
    var aSuggestions = [];
    var sTextboxValue = oAutoSuggestControl.textbox.value;
    //alert (sTextboxValue);
	//Dummy value to have one intentional blank space to allow down and up keys to select items is list contains only one item.
	var varDummyValue = " "; 
	
 	var loopLength = 0;

    if (sTextboxValue.length > 0){
	
	var sTextboxValue = sTextboxValue.toUpperCase();

        //search for matching states
        for (var i=0; i < this.states.length; i++) 
		{ 
            if (this.states[i].indexOf(sTextboxValue) >= 0) 
			{
                loopLength = loopLength + 1;
				if (loopLength <= 15) //TO REDUCE THE SUGGESTIONS DROP DOWN LIST
				{
					aSuggestions.push(this.states[i]);
				}
            } 
        }
    }

	aSuggestions.push(varDummyValue);
    //provide suggestions to the control
    oAutoSuggestControl.autosuggest(aSuggestions, bTypeAhead);
};