
function StateSuggestions() {
this.states = 
[
"ARADHANA TRADERS #SUP00000011","ARAVIND LABORATORIES C/O M/S UNIQUE #SUP00000001","BARNALI ENTERPRISE #SUP00000010","BLUE ICE CORPORATION #SUP00000003","BLUE ICE CORPORATION #SUP00000005","DAS ENTERPRISE #SUP00000012","GHOSH ENTERPRISE #SUP00000007","I-ZONE #SUP00000002","M M SUPPLIER #SUP00000008","PAYAL NOVELTY  PVT LTD. #SUP00000004","R.K. SONS AGENCIES PRIVATE LIMITED #SUP00000009"];
}

/**
 * Request suggestions for the given autosuggest control. 
 * @scope protected
 * @param oAutoSuggestControl The autosuggest control to provide suggestions for.
 */
StateSuggestions.prototype.requestSuggestions = function (oAutoSuggestControl /*:AutoSuggestControl*/,
                                                          bTypeAhead /*:boolean*/) {
    var aSuggestions = [];
    var sTextboxValue = oAutoSuggestControl.textbox.value;
    
 	var loopLength = 0;

    if (sTextboxValue.length > 0){
    
	var sTextboxValue = sTextboxValue.toUpperCase();

        //search for matching states
        for (var i=0; i < this.states.length; i++) 
		{ 
            if (this.states[i].indexOf(sTextboxValue) >= 0) 
			{
                loopLength = loopLength + 1;
				if (loopLength <= 15) //TO REDUCE THE SUGGESTIONS DROP DOWN LIST
				{
					aSuggestions.push(this.states[i]);
				}
            } 
        }
    }

    //provide suggestions to the control
    oAutoSuggestControl.autosuggest(aSuggestions, bTypeAhead);
};